diff -Naur test-for-latech/net/qsocket/qsock.c testqf-for-latech/net/qsocket/qsock.c
--- test-for-latech/net/qsocket/qsock.c	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/net/qsocket/qsock.c	2004-06-11 07:48:02.000000000 -0400
@@ -0,0 +1,1115 @@
+/* Mohammed Hasan Abbasi <habbasi@cc.gatech.edu>
+   Qsocket.c - implementation for the Qsocket api calls
+   API list:
+   qsocket(int, int, int, struct qos_params*)
+   qchange(int, struct qos_params*)
+   qshutdown(int)
+
+   qsocket() creates a socket and associates it with a class
+   it expects to be called after qos_conf()
+
+   qchange() takes a socket and associates it with a class in much the
+   same way that qsocket does. Only change is that it can take a socket
+   already associated with a class, delete the class, and add a new one.
+
+   qhutdown will simply delete the socket, the class etc etc.
+
+   Based on code snippetes from the file sch_dwcs.c,
+
+
+*/
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/kmod.h>
+#include <linux/config.h>
+#include <linux/mm.h>
+#include <linux/smp_lock.h>
+#include <linux/socket.h>
+#include <linux/file.h>
+#include <linux/net.h>
+#include <linux/interrupt.h>
+#include <linux/proc_fs.h>
+#include <linux/wanrouter.h>
+#include <linux/init.h>
+#include <linux/poll.h>
+#include <linux/cache.h>
+#include <linux/module.h>
+#include <linux/unistd.h>
+#include <linux/inet.h>
+#include <linux/netfilter.h>
+#include <linux/netlink.h>
+#include <linux/rtnetlink.h>
+#include <linux/netdevice.h>
+#include <linux/stat.h>
+#include <linux/utsname.h>
+#include <linux/mm.h>
+#include <linux/fcntl.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+#include <asm/current.h>
+#include <asm/uaccess.h>
+
+//#include <sys/syscall.h>
+#include <asm/unistd.h>
+#include <asm/uaccess.h>
+
+#include <net/ip.h>
+#include <net/sock.h>
+#include <net/tcp.h>
+#include <net/udp.h>
+#include <net/scm.h>
+#include <net/pkt_sched.h>
+#include <net/protocol.h>
+#include <linux/sch_dwcs.h>
+#include <linux/sched.h>
+#include <linux/qsocket.h>
+
+
+#ifndef FALSE
+#define FALSE 0
+#endif
+#ifndef TRUE
+#define TRUE 1
+#endif
+
+#define SLEEP_TIME HZ
+#define PORT_START 5100
+#define PORT_RANGE 100
+#define  MAX_SOCK_ADDR	128
+#define QERROR(code) do {err = code; goto err_out;}while(0);
+
+#define SYS_QCHANNEL 	13
+
+/* Global variables. */
+//static char hostname[MAXHOSTNAMELEN];
+
+extern void * sys_call_table[];
+int (*orig_qsocketcall)(int, unsigned long*);
+int (*socketcall)(int, unsigned long*);
+//int (*qos_conf)(int, int, int, char *, struct socket *, void *);
+int (*pidcall)(void);
+int (*sched_setscheduler)(pid_t, int, struct sched_param *);
+
+#include "utils.h"
+#include "dwcs.h"
+
+/*this is just for compatibility with teh newer version so that it can be compiled by just dropping it in*/
+struct qop_list *qop_base;
+
+/*
+static char *strdup(char *s)
+{
+  char *p;
+
+  p = (char *)kmalloc(strlen(s)+1, GFP_KERNEL);
+  if (p != NULL)
+    strcpy(p,s);
+  return p;
+}
+*/
+
+/*
+static void my_gethostname()
+{
+	down_read(&uts_sem);
+	memset(hostname, '\0', MAXHOSTNAMELEN);
+	memcpy(hostname, system_utsname.nodename, strlen(system_utsname.nodename));
+	if (memchr(hostname, '.', MAXHOSTNAMELEN) == NULL) {
+		strcat (hostname, ".");
+		strcat (hostname, system_utsname.domainname);
+	}
+	up_read(&uts_sem);
+}
+*/
+
+static int register_identifier(int server, int use_cpu, int use_net, char *app_id, int fd, struct dwcs_class *cl)
+{
+	//call qos_register
+//	struct sock *sk;
+	struct socket *sock;
+	int err = 0;
+	
+	
+	sock = sockfd_lookup(fd, &err);
+	if(!sock)
+	{
+		goto out;
+	}
+	
+	printk("calling qos_register\n");
+//	qos_register(server, use_cpu, use_net, app_id, sock, cl);
+	
+	sockfd_put(sock);
+  out:
+	return err;
+}
+
+static inline void unregister_identifier(int fd)
+{
+	//call qos_register
+//	struct sock *sk;
+	struct socket *sock;
+	int err = 0;
+	
+	
+	sock = sockfd_lookup(fd, &err);
+	if(!sock)
+	{
+		goto out;
+	}
+	
+	printk("calling qos_unregister\n");
+//	qos_unregister(sock);
+	
+	sockfd_put(sock);
+  out:
+	return;
+}
+
+
+
+static struct Qdisc * qsock_init_qdisc(struct net_device *dev)
+{
+	/*at some future time we can allow init to set up specific QDiscs and stuff*/
+
+	/*Start by adding a new DWCS QDisc as the root on this device
+	 *if there is already a qdisc installed there .. return 
+	 *The DWCS QDisc will have a default best effort queue class in it
+	 */
+
+	/******************************************
+	 * dev->qdisc is the pointer to the root - this should be null
+	 * 
+	 ******************************************/
+
+	int err = 0;
+	struct Qdisc *sch;
+	struct Qdisc *old_sch = NULL;
+	struct Qdisc *parent = NULL;
+	struct Qdisc_ops *ops;
+	int size;
+	int handle = 0; // = TC_H_MAKE(1, 0);
+	
+	ops = qdisc_lookup_ops_string("dwcs");
+	
+	if(ops == NULL)
+	{
+		char module_name[4+IFNAMSIZ+1];
+		sprintf(module_name, "sch_%s", "dwcs");
+		request_module(module_name);
+		ops = qdisc_lookup_ops_string("dwcs");
+	}
+
+	if(ops == NULL)
+	{
+		return NULL;
+	}
+	
+	size = sizeof(*sch) + ops->priv_size;
+	
+	sch = kmalloc(size, GFP_KERNEL);
+	if(sch == NULL)
+	{
+		return NULL;
+	}
+	
+	if(ops != qdisc_lookup_ops_string("dwcs"))
+	{
+		kfree(sch);
+		return NULL;
+	}
+	
+	skb_queue_head_init(&sch->q);
+
+	sch->ops = ops;
+	
+	sch->enqueue = ops->enqueue;
+	sch->dequeue = ops->dequeue;
+	sch->dev = dev;
+	
+	atomic_set(&sch->refcnt, 1);
+	sch->stats.lock = &dev->queue_lock;
+
+	handle = qdisc_alloc_handle(dev);
+	if(handle == 0)
+	{
+		kfree(sch);
+		return NULL;
+	}
+
+	sch->handle = handle;
+	/*initialize the dwcs qdisc here*/
+	if((err = q_dwcs_init(sch)) < 0)
+	{
+		kfree(sch);
+		return NULL;
+	}
+	ops->init(sch, NULL);
+	
+	if(qdisc_graft(dev, parent, 0, sch, &old_sch) < 0)
+	{
+		kfree(sch);
+		return NULL;
+	}
+
+// 	write_lock(&qdisc_tree_lock);
+// 	sch->next = dev->qdisc_list;
+// 	dev->qdisc_list = sch;
+// 	write_unlock(&qdisc_tree_lock);
+
+	return sch;
+	
+}
+
+asmlinkage long sys_qsocket(int family, int type, int protocol,
+			 struct qos_params *args, unsigned long *a)
+{
+
+	//a heck of a lot of definitions
+	//at some future time I will cut these down to a bare min
+
+	//network device to attach the qdisc to - we can later modify this 
+	//to attach to ALL the registered network devices .. probably
+	// a better option. 
+
+    struct net_device *temp = dev_base;
+	
+	//a kernel copy of the parameters passed in from user space
+    struct qos_params params;
+	
+	//the qdisc we are going to work on
+    struct Qdisc *qdisc = NULL;
+
+	//class ops for the qdisc
+    struct Qdisc_class_ops *cops = NULL;
+
+	//sched data for this qdisc
+    struct dwcs_sched_data *q = NULL;
+
+	//a dwcs class
+    struct dwcs_class *cl = NULL;
+    struct dwcs_class *temp_cl = NULL;
+
+	//the socket filter
+    struct socket_filter *fh = NULL;
+
+	//socket head - this contains all the socket filters
+	//attached to a class
+    struct socket_head *head = NULL;
+
+	//tcp protos - these contain the pointer to a list
+	// of all the filters
+    struct tcf_proto *tp = NULL;
+
+	//operations allowed for a filter
+	struct tcf_proto_ops *t = NULL;
+
+
+    int hash;
+    int i = 0;
+    int x = 0;
+    int err = 0;
+    int sockfd = 0;
+    struct socket *sock;
+    
+	//check if the argument set is null?
+    if(args == NULL)
+		QERROR(-EINVAL);
+	//copy the parameters from the user space. The name has to be copied separately
+    if(copy_from_user(&params, args, sizeof(struct qos_params)))
+		QERROR(-EFAULT);
+	
+    if(copy_from_user(params.dev, args->dev, sizeof(char) * IFNAMSIZ))
+		QERROR(-EFAULT);
+
+    if (params.disable == 1) {
+	sockfd = create_socket(a);
+	sock = sockfd_lookup(sockfd, &err);
+	sock->sk->reuse = 1;
+    	if (params.qos_on == 1) {
+    		//qos_conf = sys_call_table[__NR_qos_conf];
+		//qos_conf(0, 0, 0, params.app_id, sock, NULL);
+	}
+	return sockfd;
+    }
+
+	//find the device
+	//in a future implementation it might be necessary
+	//to attach the qdisc to all the devices
+    for(; temp != NULL; temp = temp->next)
+		if(!strcmp(params.dev, temp->name))
+		break;	   
+	//get the root qdisc and perform the operation on this
+    
+    qdisc = temp->qdisc;
+ 	/*clean up*/
+
+    cops = qdisc->ops->cl_ops;	
+		
+    if(qdisc == NULL)
+    {
+		qdisc = qsock_init_qdisc(temp);
+		if(qdisc == NULL)
+			QERROR(-EINVAL);
+    }
+
+    if(strcmp("dwcs", qdisc->ops->id))
+    {
+		qdisc = qsock_init_qdisc(temp);
+		if(qdisc == NULL || strcmp("dwcs", qdisc->ops->id))
+			QERROR(-EINVAL);
+    }
+
+    cops = qdisc->ops->cl_ops;
+
+	//create class and add it to teh queue. 
+	
+    q = (struct dwcs_sched_data *)qdisc->data;
+	
+    cl = (struct dwcs_class*) kmalloc(sizeof(struct dwcs_class), GFP_KERNEL);
+    if(cl == NULL)
+		QERROR(-EFAULT);
+	
+    memset(cl, 0, sizeof(struct dwcs_class));
+
+    cl->refcnt = 1;
+    if(!(cl->q = qdisc_create_dflt(qdisc->dev, &pfifo_qdisc_ops)))
+		cl->q = &noop_qdisc;
+
+    cl->qdisc = qdisc;
+    cl->attr.ipg = params.ipg;
+    cl->attr.oln = params.oln;
+    cl->attr.old = params.old;
+    cl->attr.flags = params.flags;
+    cl->attr.droppable = params.attribute;	   /* TRUE if packets can be dropped */
+	cl->attr.deadline = -1;
+	cl->attr.readytime = -1;
+	cl->attr.delay = 0;
+    cl->attr.cln  = 0;		   /* Current loss numerator. */
+    cl->attr.cld  = 0;		   /* Current loss denominator. */
+    cl->attr.cln  = cl->attr.oln;
+    cl->attr.cld  = cl->attr.old;
+    cl->attr.clt  = (100 * cl->attr.oln / cl->attr.old );
+	//attach class to qdisc
+
+	x = 0;
+	
+    for(i = 0; i < 16; i ++)
+    {
+		struct dwcs_class *c;
+		c = q->classes[i];
+		for(; c != NULL; c = c->next)
+		{
+			if(x <= TC_H_MIN(c->classid))
+				x = TC_H_MIN(c->classid);
+		}
+    }
+
+
+    cl->classid = TC_H_MAKE(qdisc->handle, (x+2)); //generate a proper value here	
+
+    hash = dwcs_hash(cl->classid);
+
+	//add the class to the queieing discpline
+	//should delay this until everything is done
+	//this will prevent spurious class constructions
+
+	dwcs_link_class(cl);
+	
+
+    q->classcount++;
+	
+	//ok now the class has been added to teh qdisc
+	//next step is to add the filter
+	//We will create the socket LAST
+	//go that its possible to revert changes without creating anything
+	//for the time being I won't do the error handling
+	//some time later we will have to modify this to support rollback
+	//which means deleting the class and the filter 
+
+	//we need some way of getting our hands on the priority
+	//for the tcf
+
+	//get the class
+
+
+    t = &cls_socket_ops; 
+    if(t == NULL)
+		QERROR(-EINVAL);
+	
+
+	//now we have our hands on the tcf_proto_ops
+    tp = (struct tcf_proto *) kmalloc(sizeof(struct tcf_proto), GFP_KERNEL);
+    memset(tp, 0, sizeof(*tp));
+    tp->ops = t;
+    tp->protocol = __constant_htons(ETH_P_ALL);	// protocol; //this should be IP
+    tp->prio = TC_H_MAKE(0xC0000000U,0U);  
+    tp->q = qdisc; //points to the parent qdisc
+    tp->classify = t->classify;
+    tp->classid = cl->classid; //points to the class which we just created
+	tp->root = NULL;
+	
+    err = t->init(tp);
+    if (err) 
+		QERROR(err);
+
+	//get the filter handle
+    if(fh == NULL)
+    {
+		if(tp->root == NULL)
+		{
+			head = kmalloc(sizeof(struct socket_head), GFP_KERNEL); 
+			if(head == NULL)
+				QERROR(-ENOBUFS);
+			memset(head, 0, sizeof(*head));
+			tp->root = head;
+		}
+
+		fh = kmalloc(sizeof(struct socket_filter), GFP_KERNEL);
+		if(fh == NULL)
+			return -ENOBUFS;
+		memset(fh, 0, sizeof(*fh));
+
+		fh->id = cl->classid;
+		fh->res.classid = cl->classid;
+		fh->pid = pidcall();
+		fh->res.class = (unsigned long)cl;
+		sockfd = create_socket(a);
+		fh->fd = sockfd;
+
+		//ok now we must create the socket!!
+
+		if(sockfd < 0)
+			QERROR(sockfd);
+
+		read_lock(&tasklist_lock);
+		{
+			struct task_struct *ts = find_task_by_pid( fh->pid );
+			struct file *fl = NULL;
+
+			if ( ts  && (fl=fcheck_files(ts->files,fh->fd) ) )
+			{
+				if ( fl->f_dentry && fl->f_dentry->d_inode )
+				{
+					fh->i_ino = fl->f_dentry->d_inode->i_ino;
+				}
+			}
+		}
+
+		read_unlock(&tasklist_lock);
+
+
+		write_lock(&qdisc_tree_lock);
+		spin_lock_bh(&temp->queue_lock);
+
+		fh->next = head->ht[socket_hash(0)];
+		wmb();
+		head->ht[socket_hash(0)] = fh;
+
+ 		q = (struct dwcs_sched_data*) qdisc->data;
+
+ 		temp_cl = q->link;
+ 		tp->next = temp_cl->filter_list;
+ 		temp_cl->filter_list = tp;
+		temp_cl->filters++;
+		spin_unlock_bh(&temp->queue_lock);
+		write_unlock(&qdisc_tree_lock);
+    }
+	else
+		QERROR(-EEXIST);
+
+	register_identifier(params.server, params.use_cpu, params.use_net, params.app_id, sockfd, cl);
+	
+
+    return sockfd;
+
+  err_out:
+
+	if(cl)
+		kfree(cl);
+
+	if(tp)
+		kfree(tp);
+
+	if(head)	
+		kfree(head);
+
+	if(fh)
+		kfree(fh);
+	
+	return err;
+}
+
+asmlinkage long sys_qshutdown(int fd, int how, unsigned long *a)
+{
+    struct net_device *dev = dev_base;
+	int err = 0;
+    struct Qdisc *qdisc;
+    struct Qdisc *leaf;
+    struct Qdisc_class_ops *cops;
+    struct dwcs_sched_data *sch_dwcs;
+    struct dwcs_class *cl, *link;
+    struct socket_filter *fh = NULL;
+    struct socket_head *head = NULL;
+    struct tcf_proto *tp = NULL;
+    int i_ino = 0;
+
+
+
+//	unregister_identifier(fd);
+//	printk("registered\n");
+	
+    read_lock(&tasklist_lock);
+    {
+		struct task_struct *ts = find_task_by_pid(pidcall() );
+		struct file *fl = NULL;
+
+		if ( ts	 && (fl=fcheck_files(ts->files, fd) ) )
+		{
+			
+		    if ( fl->f_dentry && fl->f_dentry->d_inode )
+		    {
+				i_ino = fl->f_dentry->d_inode->i_ino;
+		    }
+		}
+    }
+    read_unlock(&tasklist_lock);
+
+
+	err = socketcall(SYS_SHUTDOWN, a);
+
+    if(i_ino == 0)
+		return -EINVAL;
+
+
+    for(; dev !=NULL; dev = dev->next)
+    {
+		qdisc = dev->qdisc;
+		if(qdisc == NULL)
+		    continue;
+	
+		leaf = qdisc;
+
+
+		if(strcmp("dwcs", leaf->ops->id))
+		    continue;
+	
+
+		sch_dwcs = (struct dwcs_sched_data*) leaf->data;
+	
+		link = sch_dwcs->link;
+
+		for(tp = link->filter_list; tp; tp = tp->next)
+		{
+			if(tp->ops)
+			{
+				if(!strcmp("socket", tp->ops->kind))
+				{
+					head = tp->root;
+					if(head)
+						fh = head->ht[socket_hash(0)];
+					if(fh == NULL)
+					{
+						continue;
+					}
+					for(; fh; fh = fh->next)
+						if(fh->i_ino == i_ino)
+							goto out;
+				}
+			}
+		}
+	  out:
+		if(fh == NULL)
+		{
+		    return -EINVAL;
+		}
+		
+		//decrease ref count for the root class
+		if ( ( cl = ( void * ) fh->res.class ) == NULL )
+		{
+			if ( TC_H_MAJ ( fh->res.classid ) )
+				cl = dwcs_class_lookup ( sch_dwcs, fh->res.classid );
+		
+		}
+		
+
+		if(cl == NULL)
+		{
+			printk(KERN_ERR "cl == NULL\n");
+			return -EINVAL;
+		}
+
+
+		cops = leaf->ops->cl_ops;
+		
+		//sadly this has to be done
+		//because of the way that the classifier is used
+		//only the 0th entry is ever used	
+		fh->id = 0;
+		tp->ops->destroy(tp);
+		if(cl->filters)
+			cl->filters = 0;
+		link->filters--;
+		err = cops->delete(leaf, (unsigned long)cl);
+		return err;
+    }
+    return err;
+}
+
+asmlinkage long sys_qchange(int fd, struct qos_params *args, unsigned long *a)
+{
+
+    struct net_device *dev = dev_base;
+    struct Qdisc *qdisc;
+    struct Qdisc *leaf;
+    struct dwcs_sched_data *sch_dwcs;
+    struct dwcs_class *cl, *link;
+    struct socket_filter *fh = NULL;
+    struct socket_head *head = NULL;
+    struct tcf_proto *tp = NULL;
+    int i_ino = 0;
+	int ipg = 0, oln = 0, old = 0;
+	struct qos_params params;
+	
+	//check if teh argument set is null?
+    if(args == NULL)
+    {
+		return -EINVAL;
+    }
+
+	//copy the parameters from the user space. The name has to be copied seperatly
+    if(copy_from_user(&params, args, sizeof(struct qos_params)))
+		return -EFAULT;
+		
+    if(copy_from_user(params.dev, args->dev, sizeof(char) * IFNAMSIZ))
+    {
+		return -EFAULT;
+    }
+
+	//find the device
+	//in a future implementation it might be necessary
+	//to attach the qdisc to all the devices
+    for(; dev != NULL; dev = dev->next)
+		if(!strcmp(params.dev, dev->name))
+			break;	 
+
+	if(dev == NULL)
+		return -EINVAL;
+	
+    ipg = params.ipg;
+    oln = params.oln;
+    old = params.old;
+    
+    if(ipg == 0 || old == 0)
+		return -1;
+
+    
+    read_lock(&tasklist_lock);
+    {
+		struct task_struct *ts = find_task_by_pid(pidcall() );
+		struct file *fl = NULL;
+
+		if ( ts	 && (fl=fcheck_files(ts->files, fd) ) )
+		{
+			
+		    if ( fl->f_dentry && fl->f_dentry->d_inode )
+		    {
+				i_ino = fl->f_dentry->d_inode->i_ino;
+		    }
+		}
+    }
+    read_unlock(&tasklist_lock);
+
+    if(i_ino == 0)
+		return -EINVAL;
+
+
+	qdisc = dev->qdisc;
+	if(qdisc == NULL)
+		return -EINVAL;
+	
+	leaf = qdisc;
+
+
+	if(strcmp("dwcs", leaf->ops->id))
+		return -EINVAL;
+	
+
+	sch_dwcs = (struct dwcs_sched_data*) leaf->data;
+	
+	link = sch_dwcs->link;
+
+	for(tp = link->filter_list; tp; tp = tp->next)
+	{
+		if(tp->ops)
+		{
+			if(!strcmp("socket", tp->ops->kind))
+			{
+				head = tp->root;
+				if(head)
+					fh = head->ht[socket_hash(0)];
+				if(fh == NULL)
+				{
+					continue;
+				}
+				for(; fh; fh = fh->next)
+					if(fh->i_ino == i_ino)
+						goto out;
+			}
+		}
+	}
+  out:
+	if(fh == NULL)
+	{
+		return -EINVAL;
+	}
+		
+	//decrease ref count for the root class
+	if ( ( cl = ( void * ) fh->res.class ) == NULL )
+	{
+		if ( TC_H_MAJ ( fh->res.classid ) )
+			cl = dwcs_class_lookup ( sch_dwcs, fh->res.classid );
+		
+	}
+		
+
+	if(cl == NULL)
+	{
+		printk(KERN_ERR "cl == NULL\n");
+		return -EINVAL;
+	}
+
+
+	cl->attr.ipg = ipg;
+	cl->attr.oln = oln;
+	cl->attr.old = old;
+	cl->attr.flags = params.flags;
+	cl->attr.cln  = 0;	       /* Current loss numerator. */
+	cl->attr.cld  = 0;	       /* Current loss denominator. */
+	cl->attr.droppable = params.attribute;    /* TRUE if packets can be dropped */
+	cl->attr.cln  = cl->attr.oln;
+	cl->attr.cld  = cl->attr.old;
+	cl->attr.clt  = (100 * cl->attr.oln / cl->attr.old );			
+	return 0;
+}
+
+
+asmlinkage long sys_qsendto(int fd, void *buff, size_t len, unsigned int flags,
+							struct sockaddr *addr, int addr_len,
+							struct packet_flags *pflags, unsigned long *user_args)
+{
+	struct socket *sock;
+	char address[MAX_SOCK_ADDR];
+	int err;
+	struct msghdr msg;
+	struct iovec iov;
+	struct sock *sk;
+	struct packet_flags kpflags;
+	
+	sock = sockfd_lookup(fd, &err);
+	if (!sock){
+                 goto out;
+        }
+	iov.iov_base=buff;
+	iov.iov_len=len;
+	msg.msg_name=NULL;
+	msg.msg_iov=&iov;
+	msg.msg_iovlen=1;
+	msg.msg_control=NULL;
+	msg.msg_controllen=0;
+	msg.msg_namelen=addr_len;
+
+	if(addr)
+	{
+		err = move_addr_to_kernel(addr, addr_len, address);
+		if (err < 0)
+			goto out_put;
+		msg.msg_name=address;
+	}
+	if (sock->file->f_flags & O_NONBLOCK)
+		flags |= MSG_DONTWAIT;
+	msg.msg_flags = flags;
+
+/*qsocket specific stuff*/
+	sk = sock->sk;
+
+	if((err = copy_from_user(&kpflags, pflags, sizeof(kpflags))))
+		goto out_put;
+	sk->drop_flag = kpflags.drop_flag;
+	sk->urgent_flag = kpflags.urgent_flag;
+
+	if(kpflags.fragments != 0)
+	{
+		//application is defining its own fragmentation behaviour
+		//a value of 2 means that this is the last fragment
+		sk->fragments = kpflags.fragments;
+	}
+	else
+	{
+		sk->fragments = 0;
+	}
+
+	err = sock_sendmsg(sock, &msg, len);
+
+out_put:
+	sockfd_put(sock);
+out:
+	return err;
+}
+
+
+asmlinkage long sys_qsend(int fd, void *buff, size_t len, unsigned int flags,
+							struct packet_flags *pflags, unsigned long *user_args)
+{
+	return sys_qsendto(fd, buff, len, flags, NULL, 0, pflags, user_args);
+}
+
+asmlinkage long sys_qchannel(int fd, int server)
+{
+	struct socket *sock;
+	int err = 0;
+	
+	
+	sock = sockfd_lookup(fd, &err);
+	if(!sock)
+	{
+		goto out;
+	}
+	
+	printk("calling qos_changerole\n");
+//	qos_changerole(sock, server);
+	
+	sockfd_put(sock);
+  out:
+	return err;
+
+
+	return 0;
+}
+
+
+
+asmlinkage long sys_qinfo(int fd, struct qsocket_info *info)
+{
+	struct qsocket_info kinfo;
+	struct socket *sock;
+	struct sock* sk;
+	struct net_device *dev = dev_base;
+	struct Qdisc *qdisc = NULL, *leaf = NULL;
+	struct dwcs_sched_data *sch_dwcs = NULL;
+	struct dwcs_class *cl = NULL, *link = NULL;
+	struct socket_filter *fh = NULL;
+	struct socket_head *head = NULL;
+	struct tcf_proto *tp = NULL;
+	int i_ino = 0;
+	struct task_struct *ts;
+	int err = 0;
+	
+	//if(copy_from_user(&kinfo, info, sizeof(*info)))
+	//return -EFAULT;
+	
+	sock = sockfd_lookup(fd, &err);
+	if (!sock)
+	{
+		goto out;
+	}
+	sk = sock->sk;
+	
+
+	memset(&kinfo, 0, sizeof(kinfo));
+	
+
+	kinfo.input_qlen = sk->receive_queue.qlen;
+	
+//atomic_read(&sk->rmem_alloc);
+	//debug
+//	printk(KERN_INFO "input qlen = %ld\n", skb_queue_len(&sk->receive_queue));
+
+    read_lock(&tasklist_lock);
+    {
+		struct file *fl = NULL;
+		ts = find_task_by_pid(pidcall() );
+		if ( ts	 && (fl=fcheck_files(ts->files, fd) ) )
+		{
+			
+		    if ( fl->f_dentry && fl->f_dentry->d_inode )
+		    {
+				i_ino = fl->f_dentry->d_inode->i_ino;
+		    }
+		}
+    }
+	kinfo.cpu_time = (unsigned long) ts->times.tms_utime + 
+		(unsigned long) ts->times.tms_stime + 
+		ts->times.tms_cutime + ts->times.tms_cstime;
+	//debug
+//	printk(KERN_INFO "taks time = %ld, %ld\n", ts->times.tms_utime, ts->times.tms_stime);
+//	printk(KERN_INFO "cpu time = %ld, %ld\n", ts->per_cpu_stime[0], ts->per_cpu_utime[0]);
+
+    read_unlock(&tasklist_lock);
+
+	
+    for(; dev !=NULL; dev = dev->next)
+    {
+		qdisc = dev->qdisc;
+		if(qdisc == NULL)
+		    continue;
+	
+		leaf = qdisc;
+
+
+		if(strcmp("dwcs", leaf->ops->id))
+		    continue;
+	
+
+		sch_dwcs = (struct dwcs_sched_data*) leaf->data;
+	
+		link = sch_dwcs->link;
+
+		for(tp = link->filter_list; tp; tp = tp->next)
+		{
+			if(tp->ops)
+			{
+				if(!strcmp("socket", tp->ops->kind))
+				{
+					head = tp->root;
+					if(head)
+						fh = head->ht[socket_hash(0)];
+					if(fh == NULL)
+					{
+						continue;
+					}
+					for(; fh; fh = fh->next)
+						if(fh->i_ino == i_ino)
+							goto loop_out;
+				}
+			}
+		}
+	  loop_out:
+		if(fh == NULL)
+		{
+			// return -EINVAL;
+			goto out_put;
+		}
+		
+		//decrease ref count for the root class
+		if ( ( cl = ( void * ) fh->res.class ) == NULL )
+		{
+			if ( TC_H_MAJ ( fh->res.classid ) )
+				cl = dwcs_class_lookup ( sch_dwcs, fh->res.classid );
+		
+		}
+		
+
+		if(cl == NULL)
+		{
+			printk(KERN_ERR "cl == NULL\n");
+			goto out_put;
+		}
+
+		kinfo.output_qlen = cl->q->q.qlen;
+		kinfo.missed_deadlines = cl->attr.late;
+		kinfo.delay_jif = cl->attr.delay;
+		kinfo.sent_packets = cl->attr.sent;
+		err = 0;
+		goto out_put;
+    }
+	
+	
+out_put:
+	sockfd_put(sock);
+	if(info != NULL)
+	{
+		copy_to_user(info, &kinfo, sizeof(kinfo));
+	}
+
+out:
+	return err;
+}
+
+
+
+asmlinkage long sys_qsocketcall(int call, unsigned long *args)
+{
+    unsigned long a[10];
+    int err;
+
+    if((call<1||call>SYS_QRECVMSG))
+		return -EINVAL;
+
+    switch(call) 
+    {
+		case SYS_QSOCKET:
+			if(copy_from_user(a, args, 4*sizeof(unsigned long)))
+				return -EFAULT;
+			err = sys_qsocket(a[0],a[1],a[2], (struct qos_params*) a[3], args);
+			break;
+		case SYS_QSHUTDOWN:
+			if(copy_from_user(a, args, 2*sizeof(unsigned long)))
+				return -EFAULT;
+			err = sys_qshutdown(a[0],a[1], args);
+			break;
+		case SYS_QCHANGE: 
+			if(copy_from_user(a, args, 2*sizeof(unsigned long)))
+				return -EFAULT;
+			err = sys_qchange(a[0], (struct qos_params*) a[1], args);
+			break;
+		case SYS_QSENDTO:
+			if(copy_from_user(a, args, 7*sizeof(unsigned long)))
+				return -EFAULT;
+			err = sys_qsendto(a[0], (void*)a[1], a[2], a[3], (struct sockaddr*)a[4],
+							  a[5], (struct packet_flags*)a[6], args);
+			break;	    
+		case SYS_QSEND:
+			if(copy_from_user(a, args, 5*sizeof(unsigned long)))
+				return -EFAULT;
+			err = sys_qsend(a[0], (void*)a[1], a[2], a[3],
+							  (struct packet_flags*)a[4], args);
+			break;	    
+		case SYS_QINFO:
+			if(copy_from_user(a, args, 2 * sizeof(unsigned long)))
+				return -EFAULT;
+			err = sys_qinfo(a[0], (struct qsocket_info*)a[1]);
+			break;
+		case SYS_QCHANNEL:
+			if(copy_from_user(a, args, 2 * sizeof(unsigned long)))
+				return -EFAULT;
+			err = sys_qchannel(a[0], a[1]);
+			break;
+		default:
+			err = socketcall(call, args);
+			break;
+    }
+    return err;
+}
+
+#ifdef MODULE
+int init_module(void)
+{
+    orig_qsocketcall = sys_call_table[__NR_qsocketcall];
+    socketcall = sys_call_table[__NR_socketcall];
+    //qos_conf = sys_call_table[__NR_qos_conf];
+    pidcall = sys_call_table[__NR_getpid];
+    sys_call_table[__NR_qsocketcall] = sys_qsocketcall;
+
+    return 0;
+}
+
+void cleanup_module(void)
+{
+    sys_call_table[__NR_qsocketcall] = orig_qsocketcall;	
+}
+#endif
+
+
+#ifdef CONFIG_X86
+void qsocket_init(void)
+{
+	socketcall = sys_call_table[__NR_socketcall];
+	pidcall = sys_call_table[__NR_getpid];
+	sched_setscheduler = sys_call_table[__NR_sched_setscheduler];
+	//qos_conf = sys_call_table[__NR_qos_conf];
+}
+#endif
+MODULE_LICENSE("GPL");
+
diff -Naur test-for-latech/net/qsocket/sch_dwcs.h testqf-for-latech/net/qsocket/sch_dwcs.h
--- test-for-latech/net/qsocket/sch_dwcs.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/net/qsocket/sch_dwcs.h	2004-06-11 07:48:02.000000000 -0400
@@ -0,0 +1,163 @@
+/* 
+ * net/sched/sch_dwcs.h   DWCS algorithm scheduler.
+ *
+ *              This program is free software; you can redistribute it and/or
+ *              modify it under the terms of the GNU General Public License
+ *              as published by the Free Software Foundation; either version
+ *              2 of the License, or (at your option) any later version.
+ *
+ * Authors:     Gregory Losik <gregor@cc.gatech.edu>
+ *              Richard West <west@cc.gatech.edu>
+ *              Christian Poellabauer <chris@cc.gatech.edu>
+ *
+ * Changes:     J.D. Hollis <jdhollis@cc.gatech.edu>
+ *              cleaned up the formatting and added some comments
+ *
+ */
+ 
+
+#define TRUE	1
+#define FALSE	0
+#define MAX_CONNS       255    // GL: Technically it should be 2^16 but lets risk it...
+
+#define DWCS_VIOLATION  	0x00000001 			/* Window-constraint violation. */
+#define DWCS_WORK_CONS		0x00000002 			/* Does task support work-conservation? */
+#define DWCS_NON_DROPPABLE	0x00000008 	
+
+
+
+#include <linux/notifier.h>
+
+
+/* Scheduler attributes. Not all members are necessary for all scheduling policies. */
+typedef struct dwcs_class_attr {
+	// int cd;                    /* Class descriptor. */
+	// unsigned cnt;              /* Number pkts queued for this class. */
+
+	/* JDH: w, s, and f might not be needed as we've got a DWCS qdisc now */
+	double w;                     /* Weight. (For SFQ) */
+	double s;                     /* Start tag. (For SFQ) */
+	double f;                     /* Finish tag. (For SFQ) */
+
+	/* these are the actual, user-definable attributes */
+	long deadline;
+	long readytime;/* ok this requires a little explanation
+					  this is to maintain a specific throughput from the class
+					  thus a stream with packets to send, on an idle network
+					  won't send packets until the ready time has elasped for the 
+					  stream
+				   */
+
+	unsigned long ipg;            /* Inter-packet/msg gap. */
+	unsigned oln;                 /* Original loss numerator. */
+	unsigned old;                 /* Original loss denominator. */
+	
+	/* statistics */
+	unsigned cln;                 /* Current loss numerator. */
+	unsigned cld;                 /* Current loss denominator. */
+	long clt;                    /* Current loss tolerance. - not a float anymore
+								  * it indicates the percentage of loss tolerance instead of a fraction.
+								  *essentially multiplied by a 100 */
+	unsigned late;                /* Stats - number late pkts. */
+	unsigned sent;                /* Stats - number pkts sent. */
+	unsigned violations;          /* Stats - number loss tolerance violations. */
+	unsigned long delay;          /* Cumulative delay for this class. */
+	int t;                        /* Simulated time to process pkt. */
+	unsigned window;              /* Packet window size. */
+	unsigned wlate;               /* Count of late pkts in a time window. */
+	unsigned long bytes;          /* Total bytes serviced for this class. */
+	// long start_time;              /* Real-time this class started. */
+	
+	/* GL: since there is no per packet flag, it needs to be per stream... */
+	int droppable;                /* TRUE if packets may be dropped. */
+	unsigned int flags;           /* Flags as specified by user */
+} dwcs_class_attr_t;
+
+
+/* Deadline heap attributes. */
+struct dl_heap {
+	long deadline;                /* Packet deadline. */
+	// int stream;                   /* Stream number. */
+	u32 stream;                   /* Stream number. */
+};
+
+struct sl_heap
+{
+	long readytime;
+	u32 stream;
+};
+
+
+/* Loss tolerance heap attributes. */
+struct lt_heap {
+	int stream;                   /* Stream number. */
+	long deadline;                /* Packet deadline. */
+	int cln;                      /* Current loss numerator. */
+	int cld;                      /* Current loss denominator. */
+	int oln;                      /* Original loss numerator. */
+	int wlate;                    /* Late packets in window. */
+	unsigned long arr_time;       /* Packet arrival time. */
+	long clt;                    /* Current loss tolerance. */
+};
+
+struct dwcs_sched_data;
+ 
+struct dwcs_class
+{
+  struct dwcs_class           *next;          /* hash table link */
+  struct dwcs_class           *next_alive;    /* next class with backlog in this priority band */
+
+  /* Parameters */
+  u32                         classid;        /* the major:minor class id */
+  unsigned char		      priority;       /* class priority */
+  unsigned int		      *socket_num;    /* to be a socket number.... */
+#ifdef CONFIG_NET_CLS_POLICE
+  unsigned char	              police;
+#endif
+  struct Qdisc                *qdisc;         /* Ptr to DWCS discipline that class belongs to */
+  struct Qdisc                *q;             /* Elementary queueing discipline */
+  
+  /* Variables */
+  struct tcf_proto            *filter_list;
+  int		              refcnt;         /* used by _get() and _put() reference tracking */
+  int                         filters;        /* for keeping track the number of filters */
+  struct tc_stats             stats;          /* ??? used by _NET_ESTIMATOR */
+
+  /* DWCS  specific parameters */
+  struct dwcs_class_attr      attr;         /* Low level attributes of a class */
+};
+
+
+
+
+struct dwcs_sched_data
+{
+	struct dwcs_class         *classes[ 16 ]; /* Hash table of all classes. This is where all new calsses get inserted in */
+	struct dwcs_class         *link;           /* Default class for case when filters don't match */
+	unsigned                  classcount;     /* the counder for total # of classes; q->classes[i] has the actual list */
+
+
+	/* DWCS specific attributes */
+	struct dwcs_class         	*next_class;    /* next class from which we will try to dequeue (to be deleted) */
+
+	struct lt_heap          	ltheap[MAX_CONNS];    /* Loss-Tolerance Heap */
+	int                       	ltheap_size;
+	struct dl_heap            	dlheap[MAX_CONNS];    /* Deadline Heap */
+	int                       	dlheap_size;
+	struct sl_heap				slheap[MAX_CONNS];
+	int 						slheap_size;
+	struct timer_list 			wd_timer;	/* Watchdog timer */	
+	
+
+#ifdef CONFIG_PROC_FS
+	struct proc_dir_entry *ent;
+#endif
+
+#ifdef CONFIG_NET_CLS_POLICE
+	struct dwcs_class	    *rx_class;
+#endif
+
+};
+
+
+ 
